#include "STC8h.h"
#include "stdio.h"
#include "intrins.h"

typedef     unsigned char   u8;

typedef     unsigned int    u16;
typedef     unsigned long   u32;

#define MAIN_Fosc           22118400UL   //ʱӣȷ115200ʣ
#define Baudrate              115200UL
#define TM                        (65536-(MAIN_Fosc/Baudrate/4))

/*************        س        **************/

#define ADC_START        (1<<6)        //תλԶ0
#define ADC_FLAG        (1<<5)            // ת־λ0

#define        ADC_SPEED        15          /* 0~15, ADCתʱ䣬ADCCFG */
#define        RES_FMT  (1<<5)            /* ADCʽҶ, ADC_RES: 0 0 0 0 D11 D10 D9 D8 */
#define SUM_LENGTH        16                  //ƽֵ,ֵ16


/*************        غ        *************/
u16 Get_ADC12bitResult(u8 channel);           //ȡһͨADCת
void        delay_ms(u8 ms);                          //ʱ
void        ADC_convert(u8 chn);                    //ĳͨADתchn=0~7ӦP1.0~P1.7, chn=8~14ӦP0.0~P0.6, chn=15ӦBandGapѹ
/******************* ڳʼ ********************/
void UartInit(void)
{
        SCON = (SCON & 0x3f) | 0x40;             //1Ĺʽ18+2ģʽ
        AUXR |= 0x40;                                    //ʱʱ1Tģʽ
        AUXR &= 0xFE;                                   //1ѡʱ1Ϊʷ
       TMOD &=0x0F;                                         //T1ʽ016λԶ
        TL1 = TM;
        TH1 = TM>>8;
        TR1 = 1;                                            //ʱ1ʼʱ
}


void UartPutc(unsigned char dat)
{
    SBUF = dat;
    while(TI==0);
    TI = 0;
}

char putchar(char c)
{
    UartPutc(c);
    return c;
}


/**********************************************/
void main(void)
{
    u8  i;
    P_SW2 |= 0x80;                                           //չĴ(XFR)ʹ
    P0M1 = 0x7f;    P0M0 = 0x00;                       //Ϊ
    P1M1 = 0xff;    P1M0 = 0x00;                        //Ϊ

    ADC_CONTR = 0x80 + 0;                              //ADC on + channelADԴѡͨ0
    ADCCFG = RES_FMT + ADC_SPEED;               //ADҶ룬趨תʱ
    ADCTIM = 0x3f;                                           //ͨѡʱ䡢ʱ䡢ʱ
   ADCEXCFG = 0x07;    //ת16βȡƽֵ    //ȡ16ƽֵ

        UartInit();

        while (1)
        {
                for(i=0; i<16; i++)
                {
                        delay_ms(200);
                        ADC_convert(i);                        //ѯͨADֵ
                }
        }
}

//==================================================================
// : u16        Get_ADC12bitResult(u8 channel))        //channel = 0~15
// : ѯһADC.
// : channel: ѡҪתADC, 0~15.
// : 12λADC.
// 汾: V1.0, 2016-4-28
//=====================================================================
u16        Get_ADC12bitResult(u8 channel)        //channel = 0~15
{
        ADC_RES = 0;
        ADC_RESL = 0;

        ADC_CONTR = 0x80 | ADC_START | channel;
        NOP(10);                                                                                //ȴȶѹ
        while((ADC_CONTR & ADC_FLAG) == 0);                                   //ȴADCת
        ADC_CONTR &= ~ADC_FLAG;                                                  //ת־λ
        return ((u16)ADC_RES * 256 + (u16)ADC_RESL);
}


void        ADC_convert(u8 chn)
{
        u16  j;
              u8   k;
        Get_ADC12bitResult(chn);                                            //i=0~15,ѯʽһADC, лͨһת. ݵĲдѹӰ.

        j=Get_ADC12bitResult(chn);                                        //i=0~15,ѯʽһADC, лͨڶת. ݵĲдѹӰ.
      
               if(chn == 15)        printf("Bandgap=%04d  ",j);      //ڻ׼1.35V or 1.19V

        else                                                                           //ADC0~ADC14
        {
                printf("ADC%02bd=%04d  ",chn,j);
        }
}

void delay_ms(u8 ms)
{
        u16 i;
        do
        {
                i = MAIN_Fosc / 10000;
                while(--i);
        }while(--ms);
}